
#ifndef header_gameobject_moving
#define header_gameobject_moving

#if _MSC_VER > 1000
#pragma once
#endif

#include "gameobject.h"

class World;

class GameObject_Moving : public GameObject
{
//!Construction:
public:
	//: Construct object at position (x, y).
	GameObject_Moving(int x, int y, World *world);

	//: Destructor.
	virtual ~GameObject_Moving();

//!Attributes:
public:
	//: Returns object x position.
	virtual float get_x() { return x; }
	
	//: Returns object y position.
	virtual float get_y() { return y; }
	
protected:
	//: World object.
	World *world;

//!Operations:
protected:
	//: Set movement speed of object.
	void set_speed(float new_speed) { speed = new_speed; }

	//: Set object to move to this destination.
	void set_destination(int x, int y) { dest_x = x; dest_y = y; }

	//: Moves the object.
	bool move(float time_elapsed);
	
	//: Called when object reaches destination.
	virtual bool event_reached_dest()=0;

//!Implementation:
protected:
	bool verify_move(int dx, int dy);

	bool do_move(int dx, int dy);
	
	float x, y;

	int dest_x, dest_y;

	float speed;
};

#endif
